using System;
using System.Data;
using System.Text;
using System.Data.SqlClient; 
using ZXDT.DBUtility;//Please add references

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Msg_NoticeUsers
    /// </summary>
    public partial class T_Msg_NoticeUsers
    {
        public T_Msg_NoticeUsers()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_NoticeId", "T_Msg_NoticeUsers");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_NoticeId, int F_UserId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Msg_NoticeUsers");
            strSql.Append(" where F_NoticeId=@F_NoticeId and F_UserId=@F_UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4)          };
            parameters[0].Value = F_NoticeId;
            parameters[1].Value = F_UserId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(ZXDT.CallCenter.Model.T_Msg_NoticeUsers model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Msg_NoticeUsers(");
            strSql.Append("F_NoticeId,F_UserId,F_UserName,F_ReadDate,F_State,F_Type,F_AlertState)");
            strSql.Append(" values (");
            strSql.Append("@F_NoticeId,@F_UserId,@F_UserName,@F_ReadDate,@F_State,@F_Type,@F_AlertState)");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ReadDate", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_Type", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_AlertState", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_NoticeId;
            parameters[1].Value = model.F_UserId;
            parameters[2].Value = model.F_UserName;
            parameters[3].Value = model.F_ReadDate;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_Type;
            parameters[6].Value = model.F_AlertState;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Msg_NoticeUsers model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Msg_NoticeUsers set ");
            strSql.Append("F_UserName=@F_UserName,");
            strSql.Append("F_ReadDate=@F_ReadDate,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_AlertState=@F_AlertState");
            strSql.Append(" where F_NoticeId=@F_NoticeId and F_UserId=@F_UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_UserName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ReadDate", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_Type", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_AlertState", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_UserName;
            parameters[1].Value = model.F_ReadDate;
            parameters[2].Value = model.F_State;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_AlertState;
            parameters[5].Value = model.F_NoticeId;
            parameters[6].Value = model.F_UserId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_NoticeId, int F_UserId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Msg_NoticeUsers ");
            strSql.Append(" where F_NoticeId=@F_NoticeId and F_UserId=@F_UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4)          };
            parameters[0].Value = F_NoticeId;
            parameters[1].Value = F_UserId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Msg_NoticeUsers GetModel(int F_NoticeId, int F_UserId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_NoticeId,F_UserId,F_UserName,F_ReadDate,F_State,F_Type,F_AlertState from T_Msg_NoticeUsers ");
            strSql.Append(" where F_NoticeId=@F_NoticeId and F_UserId=@F_UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4)          };
            parameters[0].Value = F_NoticeId;
            parameters[1].Value = F_UserId;

            ZXDT.CallCenter.Model.T_Msg_NoticeUsers model = new ZXDT.CallCenter.Model.T_Msg_NoticeUsers();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Msg_NoticeUsers DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_Msg_NoticeUsers model = new ZXDT.CallCenter.Model.T_Msg_NoticeUsers();
            if (row != null)
            {
                if (row["F_NoticeId"] != null && row["F_NoticeId"].ToString() != "")
                {
                    model.F_NoticeId = int.Parse(row["F_NoticeId"].ToString());
                }
                if (row["F_UserId"] != null && row["F_UserId"].ToString() != "")
                {
                    model.F_UserId = int.Parse(row["F_UserId"].ToString());
                }
                if (row["F_UserName"] != null)
                {
                    model.F_UserName = row["F_UserName"].ToString();
                }
                if (row["F_ReadDate"] != null && row["F_ReadDate"].ToString() != "")
                {
                    model.F_ReadDate = DateTime.Parse(row["F_ReadDate"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_AlertState"] != null && row["F_AlertState"].ToString() != "")
                {
                    model.F_AlertState = int.Parse(row["F_AlertState"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_NoticeId,F_UserId,F_UserName,F_ReadDate,F_State,F_Type,F_AlertState ");
            strSql.Append(" FROM T_Msg_NoticeUsers ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_NoticeId,F_UserId,F_UserName,F_ReadDate,F_State,F_Type,F_AlertState ");
            strSql.Append(" FROM T_Msg_NoticeUsers ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Msg_NoticeUsers ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_UserId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Msg_NoticeUsers T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Msg_NoticeUsers";
			parameters[1].Value = "F_UserId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}


